//
//  NovationDisplay.h
//  vst 2.4 examples
//
//  Created by ppad on 05/05/2015.
//
//

#ifndef __NovationDisplay__
#define __NovationDisplay__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <RtMidi.h>

namespace stk {

class NovationDisplay
{
public:
    NovationDisplay(RtMidiOut* dispPort);
    ~NovationDisplay();
        
    void reset(void);
    void AllLightsOn(void);
    void AllLightsOff(void);
      
    void clearRightLCD(void);
    void clearLeftLCD(void);
    void changeToReasonAutomapTemplate(void);
    
    // where row 1=topleft, 2=topright, 3=btmleft, 4=btmright
    void lcdText(int row, char* text);
    void lcdClearText(int row, char* text); // clear first
    
    // where pos 0=farleft, 40=farright and anything inbetween
    void lcdTextPos(int pos, int row, char* text);
private:
   RtMidiOut* port;
   void lcdClear(int id);
};

} // namespace stk
 
#endif // __NovationDisplay__
