#ifndef VSTXRESOFILTER_H
#define VSTXRESOFILTER_H

/*! \class VSTXResoFilter
    \brief dspwiki lowpass resonant biquad

    http://dspwiki.com/index.php?title=Lowpass_Resonant_Biquad_Filter
*/

class VSTXResoFilter
{
    public:
        /** Default constructor */
        VSTXResoFilter(float sampleRate);

        void filterConfig(float cutoffHz, float reso);
        float filter(float sval);

    protected:
    private:
        float fCutoff; //!< Member variable "fCutoff"
        float fResonance; //!< Member variable "fResonance"
        float fSampleRate; //!< Member variable "fSampleRate"


        // member variables
        float bufferIn[2], bufferOut[2];
        float c, a1, a2, a3, b1, b2;
};

#endif // VSTXRESOFILTER_H
