#include "VSTXEnvelope.h"

VSTXEnvelope::VSTXEnvelope( float sampleRateVal )
{
    sampleRate = sampleRateVal;

    target = current = 0.0;
    attackRate = decayRate = releaseRate = 0.05;
    sustainLevel = 0.7;
    state = IDLE;
}

VSTXEnvelope::~VSTXEnvelope()
{
    //dtor
}

void VSTXEnvelope::keyOn()
{
  // TODO: add attackLevel parameter
  float attackLevel = 1.0;
  target = attackLevel;
  state = ATTACK;
}

void VSTXEnvelope::keyOff()
{
  target = 0.0;
  state = RELEASE;
}

float VSTXEnvelope::tick()
{

   //(1 - ( fooRate / kMaxTime) ) / sampleRate;

  switch ( state ) {

  case ATTACK:
    current += attackRate;
    if ( current >= target ) {
      current = target;
      target = sustainLevel;
      state = DECAY;
    }
    break;

  case DECAY:
    current -= decayRate;
    if ( current <= sustainLevel ) {
      current = sustainLevel;
      state = SUSTAIN;
    }
    break;

  case RELEASE:
    current -= decayRate;
    if ( current <= 0.0 ) {
      current = 0.0;
      state = IDLE;
    }

  }

  return current;
}
